## wildmidi 0.4.2

=== debian/changelog ===
wildmidi (0.4.2-1) unstable; urgency=medium

  [ Bret Curtis ]
  * New upstream release.
    - Fix CVE-2017-11661, CVE-2017-11662, CVE-2017-11663. (Closes: #871616)
    - Fix CVE-2017-1000418. (Closes: #886503)
  * Declare compliance with Debian Policy 4.1.3.

  [ Markus Koschany ]
  * Switch to compat level 11.

 -- Bret Curtis <psi29a@gmail.com>  Sun, 07 Jan 2018 00:45:44 +0100
