=== debian/changelog ===
wildmidi (0.4.3-1build3) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Apr 2024 07:24:20 +0000

wildmidi (0.4.3-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 08:33:12 +0000

wildmidi (0.4.3-1build1) noble; urgency=medium

  * No-change rebuild against libasound2t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:05:15 +0000

wildmidi (0.4.3-1) unstable; urgency=medium

  * New upstream release.
  * Relaxed package dependencies, thanks Fabian Greffrath (Closes: 612509)

 -- Bret Curtis <psi29a@gmail.com>  Wed, 06 Feb 2019 14:46:31 +0100
