=== debian/control ===
--- 
+++ 
@@ -1,20 +1,22 @@
 Source: wildmidi
 Section: sound
 Priority: optional
-Maintainer: Bret Curtis <psi29a@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Bret Curtis <psi29a@gmail.com>
 Uploaders: Emmet Hikory <emmet.hikory@gmail.com>, Sebastian Dröge <slomo@debian.org>
 Build-Depends: debhelper (>= 11),
                cmake,
                libasound2-dev [linux-any]
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Homepage: http://www.mindwerks.net/projects/wildmidi/
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/wildmidi.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/wildmidi.git
+Vcs-Browser: https://salsa.debian.org/games-team/WildMIDI
+Vcs-Git: https://salsa.debian.org/games-team/WildMIDI.git
 
 Package: wildmidi
 Architecture: any
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Recommends: libwildmidi-config
 Description: software MIDI player
  Minimal MIDI player implementation based on the wildmidi library that
  can either dump to WAV or playback over ALSA. It is intended to
@@ -26,9 +28,9 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libwildmidi-config,
-         ${shlibs:Depends},
+Depends: ${shlibs:Depends},
          ${misc:Depends}
+Suggests: libwildmidi-config
 Replaces: libwildmidi0
 Description: software MIDI player library
  MIDI streaming library designed to process a MIDI file using sound patches
@@ -40,6 +42,7 @@
 Architecture: any
 Depends: libwildmidi2 (= ${binary:Version}),
          ${misc:Depends}
+Recommends: libwildmidi-config
 Description: software MIDI player library headers
  MIDI streaming library designed to process a MIDI file using sound patches
  and stream the results as stereo audio data through a buffer which an
